All requests to the Engine by MoneyLion API must be authenticated using a bearer token.
There are two types of bearer tokens:
Publishable tokens can be published in application code and downloaded to a user's device. As a result,
they only have restricted access to the API.
Confidential tokens must be managed like a password or any other confidential secret. As a result, they
have access to sensitive API endpoints.
Experimental tokens are used to access endpoints that are not yet available for all partners.
They may be treated the same as a publishableBearerToken.
A valid bearer token is formatted as two UUIDs concatenated with an underscore. A token must be specified
in the Authentication header of each request. The header value must start with the string "Bearer",
followed by a single space, followed by the bearer token with no trailing whitespace.
Response Types
The Engine by MoneyLion API responds with meaningful HTTP response codes that follow
REST conventions.
Response codes in the 2xx range indicate that the request succeeded
while codes in the 4xx range indicate that the request failed.
4xx failures can be resolved by the client by altering request data.
However, if a request failure is due to an Engine by MoneyLion server error, a code in the
5xx range will be returned. This response type is rare, and as such
is not further documented.
Success
There are two potential 2xx response codes:
200 OK - A succesful read request to a GETendpoint.
201 Created - A successful request to create a new resource via a
POST endpoint.
The response body will contain either the requested data, or the newly
created resource.
Failure
There are four potential 4xx response codes:
400 Bad Request - A malformed request that could not be parsed
prior to processing.
401 Unauthorized - A request that either could not be authenticated due
to a missing or malformed Authorization header or unknown bearer token
or could not be authorized due to insufficient permissions.
404 Not Found - A request that either references an unknown path,
or specifies an unknown UUID as a path parameter.
422 Unprocessable Entity - A request that fails validation or is
otherwise in violation of documented business logic.
Regardless of response code, the body will match the
ApiError schema.
Financial Products
The lead schema is not specific to any particular financial product. As a result, no fields are required, and the desired financial product types are indicated via the productTypes array.
There are requirements associated with each of these values, and in the case of loans, those requirements may be specific to the desired loan sub-type. All are detailed below.
Loans
Personal Loan Request
POST /leads/rateTables
{
"productTypes": [
"loan"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyStatus": "own_with_mortgage"
},
"creditInformation": {
"providedCreditRating": "excellent"
},
"financialInformation": {
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 75000
},
"educationInformation": {
"educationLevel": "masters"
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"tcpaLanguage": "I agree to be contacted by Engine by MoneyLion and its partners at the telephone number(s) I have provided above to explore personal loan offers, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. I understand my consent is not required as a condition to purchasing any goods or services from anyone.",
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by MoneyLion and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services"
},
"clientTags": {
"subId": [
"aaa053cb"
]
}
}
Personal Loan Response
200 OK
{
"uuid": "2c6cb6e4-0aa2-4ab5-9109-8679de537e10",
"leadUuid": "f823a7c0-586a-4fc3-9cfa-c38694b80b2c",
"loanOffers": [
{
"uuid": "fef16e91-960f-4ac7-a8ec-98d7a6b32c7e",
"originator": {
"key": "lending-club",
"name": "LendingClub",
"description": "Low fixed rate personal loans from $1,000 to $40,000",
"images": [
{
"sizeKey": "150",
"url": "aff-tag.evenfinancial.com/images/lendingclub/lendingclub_120.png"
}
],
"disclaimer": "Suspendisse rhoncus magna erat, nec rhoncus leo elementum eget."
},
"originatorId": null,
"termLength": 36,
"termUnit": "month",
"maxAmount": 12000,
"minAmount": 800,
"maxApr": 35.99,
"minApr": 25.01,
"meanApr": 30.5,
"feeRate": null,
"maxFeeRate": null,
"minFeeRate": null,
"feeFixed": null,
"maxFeeFixed": null,
"minFeeFixed": null,
"allowPrepayment": true,
"prepaymentFee": 0,
"monthlyPayment": 119.3,
"maxMonthlyPayment": 137.4,
"minMonthlyPayment": 119.3,
"meanMonthlyPayment": 128.18,
"maxTotalPayment": 4947,
"minTotalPayment": 4295,
"meanTotalPayment": 4615,
"terms": null,
"url": "https://offers.evenfinancial.com/ref/fef16e91-960f-4ac7-a8ec-98d7a6b32c7e",
"preQualified": false,
"preApproved": true,
"sponsored": false,
"aprType": "fixed",
"recommendationScore": 95,
"amountPrefix": null
},
...
],
"specialOffers": [],
"savingsOffers": [],
"creditCardOffers": [],
"mortgageOffers": [],
"pendingResponses": [
{
"partner": {
"uuid": "91d08be0-2a8c-4d28-b399-7e1b38e2522e",
"name": "Avant",
"description": "Personal loans from $1,000 to $35,000",
"disclaimer": "Suspendisse rhoncus magna erat, nec rhoncus leo elementum eget.",
"imageUrl": "https://images.evenfinancial.com/old/images/avant/avant_120.png"
},
"productTypes": [
"loan"
]
}
],
"pendingOriginators": [
{
"key": "avant",
"name": "Avant",
"description": "Personal loans from $1,000 to $35,000",
"images": [
{
"sizeKey": "120",
"url": "aff-tag.evenfinancial.com/images/avant/avant_120.png"
}
],
"disclaimer": "Suspendisse rhoncus magna erat, nec rhoncus leo elementum eget."
}
]
}
The loan product type includes the following:
Personal Loans
Student Loan Refinancing
Co-Applicant Loans
Secured Loans
Line of Credit
To search for any loan product, you must set productTypes
to ["loan"] on the lead.
Personal Loans
Unsecured personal loans require no collateral and can be used for a large
variety of purposes, but may have higher interest rates than other types of
loans.
In order to get pre-approved and pre-qualified personal loan offers,
you should specify the following fields on the lead:
personalInformation.firstName
personalInformation.lastName
personalInformation.address1
personalInformation.address2 (when applicable)
personalInformation.city
personalInformation.state
personalInformation.zipcode
personalInformation.email
personalInformation.primaryPhone
personalInformation.dateOfBirth
personalInformation.ssn
loanInformation.purpose
loanInformation.loanAmount
mortgageInformation.propertyStatus
creditInformation.providedCreditRating or creditInformation.providedNumericCreditScore
financialInformation.employmentStatus
financialInformation.employmentPayFrequency
financialInformation.annualIncome
educationInformation.educationLevel
legalInformation.consentsToTcpa
legalInformation.consentsToFcra
legalInformation.tcpaLanguage
legalInformation.fcraLanguage
Auto Loan Refinancing
Searching for automobile refinancing loans is just like searching for
personal loans, but with some additional requirements:
loanInformation.purpose must be "auto_refinance".
financialInformation.monthlyHousingPayment must be specified.
vehicleInformation.monthlyPayment must be specified.
vehicleInformation.estimatedMileage must be specified.
vehicleInformation.vehicleIdentificationNumber or
vehicleInformation.vehicleUuid must be specified.
if vehicleInformation.vehicleUuid is specified it must come from a valid
year/make/model/trim combination from the GET /leads/vehicles/trims utility endpoint.
Student Loan Refinancing
Refinancing your existing student loans enables you to consolidate your debt,
possibly at a lower rate, but only student loans are eligible.
Searching for student loan refinancing loans is just like searching for
personal loans, but with some additional requirements:
productSubTypes must be ["student_loan_refinance"]
loanInformation.purpose must be "student_loan_refi"
educationInformation.graduationDate must be specified.
financialInformation.monthlyHousingPayment must be specified.
financialInformation.availableAssets must be specified.
personalInformation.citizenshipStatus must be specified.
educationInformation.universityAttended must be specified. This is a
free form text field for the university name, which should be taken from
the GET /leads/universities utility endpoint.
if educationInformation.educationLevel is "doctorate", then
educationInformation.graduateDegreeType must be specified.
Co-Applicant Loans
A co-applicant loan requires a consignor and leverages their credit to help
you possibly get a better rate. You are both responsible for paying back the
loan.
The consignor information is specified on the coApplicantInformation
sub-object and must be specifed in addition to the fields required
for personal loans to potentially get co-applicant loans offers
coApplicantInformation.firstName
coApplicantInformation.lastName
coApplicantInformation.address1
coApplicantInformation.address2 (when applicable)
coApplicantInformation.city
coApplicantInformation.state
coApplicantInformation.zipcode
coApplicantInformation.dateOfBirth
coApplicantInformation.annualIncome
Secured Loans
Secured Loans require collateral, such as an investment account, car, or
other asset in order to guarantee the loan. Their interest rates may be lower
than unsecured loans depending on several factors.
Secured loan offers will be automatically returned alongside unsecured
personal loan offers if the lead meets criteria.
Line of Credit
A line of credit is a financial product that you can borrow from at any time
based on a preset limit. As you pay it off over time, that credit will once
again become available for you to borrow from. You will pay interest only on
the amount you borrow.
Line of credit offers will be automatically returned alongside
personal loan offers if the lead meets criteria.
To search for savings accounts, you should set productTypes to
["savings"] on the lead. To get the best matching offers, you should
also specify the following fields:
personalInformation.zipcode
savingsInformation.minDepositAmount
Credit Cards
Credit Card Request
POST /leads/rateTables
{
"productTypes": [
"credit_card"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10011",
"dateOfBirth": "1993-10-09"
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"creditInformation": {
"providedCreditRating": "excellent",
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"tcpaLanguage": "I agree to be contacted by Engine by MoneyLion and its partners at the telephone number(s) I have provided above to explore personal loan offers, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. I understand my consent is not required as a condition to purchasing any goods or services from anyone.",
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by MoneyLion and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services"
},
"clientTags": {
"subId": [
"2ee169ef"
]
}
}
To search for credit cards, you should set productTypes to
["credit_card"] on the lead. To get the best matching offers, you should
also specify the following fields:
personalInformation.firstName
personalInformation.lastName
personalInformation.address1
personalInformation.address2 (when applicable)
personalInformation.city
personalInformation.state
personalInformation.zipcode
personalInformation.email
personalInformation.dateOfBirth
creditInformation.providedCreditRating or creditInformation.providedNumericCreditScore
creditCardInformation.cardPurposes
creditCardInformation.allowAnnualFee
legalInformation.consentsToFcra
legalInformation.consentsToTcpa
legalInformation.tcpaLanguage
legalInformation.fcraLanguage
Endpoints
Lead
A lead combines information about a user with search criteria for financial products, and is submitted in exchange for a rate table.
A rate table is a list of financial offers that match a submitted lead.
Lead Details
No fields are required on a lead, but depending on the type of product requested, a minimum subset is required in order to potentially receive personalized offers. For details, see the Financial Products overview.
A lead may request multiple product types, in which case the returned rate table will include a list for each product type with matching offers.
Asynchronous Rate Tables
Often a rate table will be built asynchronously. This means that although the rate table gets returned, the API may still be waiting for responses from one or more financial institutions. In these cases, you should poll the rate table until all responses are resolved before displaying the offers to the end user.
So, if you submit a lead via the "Submit lead" endpoint and the returned rate table has a non-empty pendingResponses array, you should reload the rate table via the "Get rate table" endpoint, and continue to do so until pendingResponses is empty.
Submit lead
Code sample
curl -X POST 'https://api.engine.tech/leads/rateTables' \
-H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer {access-token}' \
-d @- << EOF
{
"productTypes": [
"loan"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"primaryPhone": "2125556789",
"address1": "175 5th Ave",
"zipcode": "10010",
"monthsAtAddress": 72,
"activeMilitary": false,
"militaryVeteran": false,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"personalReferenceInformation": {},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyStatus": "own_with_mortgage"
},
"creditCardInformation": {},
"savingsInformation": {},
"creditInformation": {
"providedCreditRating": "good"
},
"financialInformation": {
"employmentStatus": "employed",
"employmentPayFrequency": "biweekly",
"annualIncome": 80000
},
"employmentInformation": {},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"consentsToSms": false,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"educationInformation": {
"educationLevel": "bachelors"
},
"coApplicantInformation": {},
"healthInformation": {},
"lifeInsuranceInformation": {},
"refinanceLoans": [],
"identificationInformation": {},
"clientTags": {
"transid": [
"fk912234"
],
"subid": [
"ag67125"
]
},
"isTest": false,
"sessionUuid": "c363ec58-c5f0-54ff-b8f7-0f5f630213d9"
}
EOF
fetch('https://api.engine.tech/leads/rateTables', {
method: 'POST',
headers: {
'Content-Type':'application/json',
'Accept':'application/json',
'Authorization':'Bearer {access-token}'
},
body: `{
"productTypes": [
"loan"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"primaryPhone": "2125556789",
"address1": "175 5th Ave",
"zipcode": "10010",
"monthsAtAddress": 72,
"activeMilitary": false,
"militaryVeteran": false,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"personalReferenceInformation": {},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyStatus": "own_with_mortgage"
},
"creditCardInformation": {},
"savingsInformation": {},
"creditInformation": {
"providedCreditRating": "good"
},
"financialInformation": {
"employmentStatus": "employed",
"employmentPayFrequency": "biweekly",
"annualIncome": 80000
},
"employmentInformation": {},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"consentsToSms": false,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"educationInformation": {
"educationLevel": "bachelors"
},
"coApplicantInformation": {},
"healthInformation": {},
"lifeInsuranceInformation": {},
"refinanceLoans": [],
"identificationInformation": {},
"clientTags": {
"transid": [
"fk912234"
],
"subid": [
"ag67125"
]
},
"isTest": false,
"sessionUuid": "c363ec58-c5f0-54ff-b8f7-0f5f630213d9"
}`
}).then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});
import requests
import json
response = requests.post(
'https://api.engine.tech/leads/rateTables',
headers={
'Content-Type': 'application/json',
'Accept': 'application/json',
'Authorization': 'Bearer {access-token}'
},
json=json.loads("""{
"productTypes": [
"loan"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"primaryPhone": "2125556789",
"address1": "175 5th Ave",
"zipcode": "10010",
"monthsAtAddress": 72,
"activeMilitary": false,
"militaryVeteran": false,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"personalReferenceInformation": {},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyStatus": "own_with_mortgage"
},
"creditCardInformation": {},
"savingsInformation": {},
"creditInformation": {
"providedCreditRating": "good"
},
"financialInformation": {
"employmentStatus": "employed",
"employmentPayFrequency": "biweekly",
"annualIncome": 80000
},
"employmentInformation": {},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"consentsToSms": false,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"educationInformation": {
"educationLevel": "bachelors"
},
"coApplicantInformation": {},
"healthInformation": {},
"lifeInsuranceInformation": {},
"refinanceLoans": [],
"identificationInformation": {},
"clientTags": {
"transid": [
"fk912234"
],
"subid": [
"ag67125"
]
},
"isTest": false,
"sessionUuid": "c363ec58-c5f0-54ff-b8f7-0f5f630213d9"
}""")
)
print(response.json())
require 'rest-client'
require 'json'
response = RestClient.post(
'https://api.engine.tech/leads/rateTables',
%q|{
"productTypes": [
"loan"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"primaryPhone": "2125556789",
"address1": "175 5th Ave",
"zipcode": "10010",
"monthsAtAddress": 72,
"activeMilitary": false,
"militaryVeteran": false,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"personalReferenceInformation": {},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyStatus": "own_with_mortgage"
},
"creditCardInformation": {},
"savingsInformation": {},
"creditInformation": {
"providedCreditRating": "good"
},
"financialInformation": {
"employmentStatus": "employed",
"employmentPayFrequency": "biweekly",
"annualIncome": 80000
},
"employmentInformation": {},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"consentsToSms": false,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"educationInformation": {
"educationLevel": "bachelors"
},
"coApplicantInformation": {},
"healthInformation": {},
"lifeInsuranceInformation": {},
"refinanceLoans": [],
"identificationInformation": {},
"clientTags": {
"transid": [
"fk912234"
],
"subid": [
"ag67125"
]
},
"isTest": false,
"sessionUuid": "c363ec58-c5f0-54ff-b8f7-0f5f630213d9"
}|,
{
'Content-Type' => 'application/json',
'Accept' => 'application/json',
'Authorization' => 'Bearer {access-token}'
}
)
p JSON.parse(response)
POST /leads/rateTables
Submit a lead and get a rate table. If the rate table has a non-empty pendingResponses array, reload it via the "Get rate table" endpoint. For more details see the Lead overview.
curl -X POST 'https://api.engine.tech/leads/{leadUuid}/rateTables' \
-H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer {access-token}' \
-d @- << EOF
{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}
EOF
fetch('https://api.engine.tech/leads/{leadUuid}/rateTables', {
method: 'POST',
headers: {
'Content-Type':'application/json',
'Accept':'application/json',
'Authorization':'Bearer {access-token}'
},
body: `{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}`
}).then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});
import requests
import json
response = requests.post(
'https://api.engine.tech/leads/{leadUuid}/rateTables',
headers={
'Content-Type': 'application/json',
'Accept': 'application/json',
'Authorization': 'Bearer {access-token}'
},
json=json.loads("""{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}""")
)
print(response.json())
require 'rest-client'
require 'json'
response = RestClient.post(
'https://api.engine.tech/leads/{leadUuid}/rateTables',
%q|{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}|,
{
'Content-Type' => 'application/json',
'Accept' => 'application/json',
'Authorization' => 'Bearer {access-token}'
}
)
p JSON.parse(response)
Get the rate table for a specified UUID. If the UUID is unkown, a 404 Not Found response will be returned.
Usually used to poll a rate table that has pending responses immediately after creation via the "Submit lead" endpoint. For more details see the Lead overview.
curl -X PATCH 'https://api.engine.tech/leads/{uuid}' \
-H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer {access-token}' \
-d @- << EOF
{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}
EOF
fetch('https://api.engine.tech/leads/{uuid}', {
method: 'PATCH',
headers: {
'Content-Type':'application/json',
'Accept':'application/json',
'Authorization':'Bearer {access-token}'
},
body: `{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}`
}).then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});
import requests
import json
response = requests.patch(
'https://api.engine.tech/leads/{uuid}',
headers={
'Content-Type': 'application/json',
'Accept': 'application/json',
'Authorization': 'Bearer {access-token}'
},
json=json.loads("""{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}""")
)
print(response.json())
require 'rest-client'
require 'json'
response = RestClient.patch(
'https://api.engine.tech/leads/{uuid}',
%q|{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}|,
{
'Content-Type' => 'application/json',
'Accept' => 'application/json',
'Authorization' => 'Bearer {access-token}'
}
)
p JSON.parse(response)
PATCH /leads/{uuid}
Update a Lead by its UUID. Array fields (like productTypes) with new values are merged with existing values.
Preview offers are matched based upon a simple set of anonymous criteria and as a result are not personalized. This is useful if you'd like to display offers without requesting personalized data. For example, you can improve a search experience by presenting example offers to the user prior to asking more detailed questions.
Offers returned by these endpoints are identical to those that would be included in a rate table. But keep in mind that they are not personalized, and it's a better user experience to ultimtely present personalized offers to a user.
Get a list of non-personalized savings offers that match the specified critieria.
Parameters
Name
Type
Required
Description
maxDepositAmount
integer [int64]
false
none
minDepositAmount
integer [int64]
false
none
zipCode
string
false
none
Example responses
Success
[
{
"uuid": "9284470f-e430-5473-aeeb-f61c91adabc9",
"productType": "savings",
"productSubType": "savings_account",
"partner": {
"uuid": "91d08be0-2a8c-4d28-b399-7e1b38e2522e",
"name": "Beta Inc.",
"description": "Voluptas quas aspernatur aut nihil rerum. Voluptatibus laboriosam amet porro veniam ut.",
"disclaimer": "Est delectus et rem consequatur magni. Molestiae asperiores sit debitis et id corporis.",
"supportsPersonalizedOffers": false,
"supportsPreSelect": false,
"shouldDisplayPreSelect": true,
"imageUrl": "https://aff-tag.evenfinancial.com/images/beta/Beta_120x80.png"
},
"url": "https://offers.evenfinancial.com/ref/0803947c-08a5-59eb-ae58-8468c62bb5a8",
"recommendationScore": 170,
"disclaimer": "Accounts offered by Axos Bank, Member FDIC",
"details": {
"name": "Beta Savings",
"description": "Pariatur et repellat quia aliquid. Sint qui aut harum qui aut.",
"details": "Praesentium asperiores est quisquam ad qui est. Sint culpa harum id totam. Ex fugit magni quis tempora sit.",
"rate": 0.4,
"annualPercentYield": 0.4,
"compoundingMethod": "continuous",
"minimumDeposit": 0,
"minimumDepositWithFees": 0,
"monthlyFee": 0,
"checkWriting": false,
"effectiveAsOf": "2021-01-01T12:00:00Z"
}
}
]
Welcome to Engine by Gen's Integration Guide for our Supply Analytics data product, which provides funnel, payout and client tag data on specific leads and lead segments to better improve your monetization, consumer experience and efficiency of user acquisition.
Refer to Developer Center for detailed information on how to use this API.
Supply Analytics offers three different reporting endpoints optimized for streaming time series datasets out of the Engine by Gen API and into your system via periodic polling, as well as an endpoint to obtain a snapshot of all information regarding a single lead. This document contains everything needed to understand and integrate with all 4 endpoints offered.
API Versions
This document describes version 3 of the Supply Analytics API. The previous version available to partners is referred to as version 1. Version 2 was an internal release.
All HTTP requests for this version must include header API-Version: 2025-04-01.
API Endpoints
We currently offer the following reporting endpoints providing real time insights into the funnel from user acquisition through conversion:
LeadEvents: This endpoint tracks the lead funnel’s journey. With the Lead Events API, you can pull KPI related data for your funnel, measure conversions, and iterate so that you can meet your business goals.
LeadPayouts: This endpoint tracks payout by conversion on a per-lead basis.
LeadClientTags: This endpoint is used to check and confirm which client tags (ie. subID, clickID, or trafficsource) you have appended to each lead (unique Engine by Gen generated leadUuid). It provides better customer segmentation and attribution by returning your supplied client-tags (key/value) pairs associated with a lead. It's explained with examples in depth in the "Get lead client tags endpoint" section.
The above endpoints can be used to stream information into your system and will be referred to as streaming endpoints. Additionally, we have the following endpoint to access an on-demand snapshot of lead information:
LeadsInfo: This endpoint provides a combined snapshot of information about a single lead — all of its events, payouts and client tags in a single request.
Basic Request to Supply Analytics API
Every request to the Supply Analytics API streaming endpoints will return a JSON object with the following properties:
data is the array of objects that should be analyzed / loaded into your
database.
nextUrl is the URL that should be persisted and used for the next
request. It will include a paginationToken.
shouldContinuePolling is a boolean which signals if calling nextUrl
will have published data available.
paginationToken is an opaque cursor that identifies the end of the
current page and is used for the next request. It is already included in
nextUrl and also provided separately for convenience.
Events from financial institutions or other external systems may not be shared with Engine by Gen for hours or days after they occur; using paginationToken ensures that backfilled records are not missed.
A response contains all available data subject to the response size limit and any applied filters (such as untilTimestamp). Requesting a URL with a sinceTimestamp that is less than five minutes old will return an error, as it can take a few minutes to prepare the response. We suggest polling hourly as a starting point, but as long as you follow shouldContinuePolling, you can poll at any interval (>5 minutes). For convenience, we provide a shouldContinuePolling flag to indicate whether you should continue to poll the Supply Analytics endpoint. If true, continue with the nextUrl. If not, no further data is currently available.
Since paginationToken is initially not known, the initial request may specify the sinceTimestamp parameter. In the absence of both of them, the endpoint will start with the oldest record in the system. The nextUrl from response will only include paginationToken.
Developer's Note About Time Zones
Timestamps without an explicit timezone (timezones missing a suffix of Z, for example) are interpreted as UTC. However, we recommend passing an explicit timezone offset of Z in the timestamp query string parameter. All timestamps in responses, whether in the event as a field, or in the nextUrl, are UTC.
Developer's Note About Flexible JSON Objects
Engine by Gen's goal is to enrich the data provided by the Supply Analytics endpoint over time to improve your insight and analytical abilities. Therefore, it is recommended that any integration or initial setup be created with the future possibility of additional data fields in mind. These will take the form of additional JSON keys. We'd recommend that your integration remain compatible if there are additional JSON key-values present. This will allow new rollouts and improvements to the supply analytics endpoint to happen as smoothly as possible.
Backfilling
When backfilling, the sinceTimestamp of your initial request URL should be to your starting point. You should request each subsequent URL in succession until you're caught up. You can use untilTimestamp to define the end time of backfill windows.
Resources
Partners can contact their assigned Engine by Gen Partner Manager or [email protected] for help.
With the Lead Events API, you can pull KPI related data for your funnel, measure conversions, and iterate so that you can meet your business goals.
The endpoint returns events associated with each lead. The event type is indicated by the eventType property. Each event will also include metadata applicable to the eventType. It allows easy consumption of the events into your database so that you can integrate it into your BI framework and compare it alongside data from other systems to assess performance holistically.
How does it work?
The endpoint is cursor based. You can consume batches of events for the product tied to your sub account. All that is required is a bearer token and previous paginationToken or sinceTimestamp. The endpoint will respond with all of the events that have happened from that point forward subject to optional untilTimestamp parameter and page size limit. It will also include a pointer to the next page (paginationToken) to be used for a subsequent call. This endpoint should be polled hourly to fetch new events.
For convenience, we provide a shouldContinuePolling flag to signal if data has been published at the location of the nextUrl. Since the endpoint will return as much data as it can, unless there is more data that can fit in a single response, this flag will usually be false as all available data has been returned.
The endpoint is designed for paging forward through data in order to populate your local database. By relying on the nextUrl parameter provided in the preceding call's response, we can guarantee a) you will see no gaps, and b) you will see no duplicates.
If constructing the url manually, subsequent requests should use paginationToken from the last response and omit sinceTimestamp.
This endpoint should be polled no more frequently than every 5 minutes, we recommend hourly. Data for this endpoint is made available with a 5 minute SLA.
If the current time is '2020-01-01T00:15:00Z' UTC, making a request to this endpoint with the timestamp set to '2020-01-01T00:14:00Z' will error because of the 5 minute SLA. Making a request with a timestamp of '2020-01-01T00:09:00Z' however, will succeed.
[
{
"attribute": "timestamp",
"type": "missing",
"message": "timestamp must be specified"
}
]
[
{
"attribute": "timestamp",
"type": "malformed",
"details": {
"specified": "2021-02-01T17:00:00.000Z",
"requirement": "must be at or before 2021-01-13T16:00:00Z"
},
"message": "timestamp must be at or before 2021-01-13T16:00:00Z, but is '2021-02-01T17:00:00Z'"
}
]
With Lead payout API you can collect granular payout information for leads you have submitted. It returns payout events associated with a lead. Event data is limited to the amount that was paid out, and when the payout was booked.
We recently added two additional optional fields to the payout event information tied to leads:
financialInstitutionUuid
financialInstitutionName
These fields will tie conversion events to specific Financial Institutions (Lenders) for your knowledge and analytical use. We include these additional fields to disambiguate which financial institution a given payout originates from in the case of multiple payouts against a given lead. Not all lead payout events can be traced back to a financial institution, so these fields are optional. The Financial Institution Name is not guaranteed to be a stable identifier of the entity; Financial Institution UUID is.
LeadPayout deletedAt will report the time that the payout was deleted. Payouts get deleted when there are post dated Contract changes or partner reporting errors requiring reingestion of EDEs.
How does it work?
The endpoint is cursor based. You can consume batches of events for the product tied to your company uuid. All that is required is a bearer token and previous paginationToken or sinceTimestamp. The endpoint will respond with all of the events that have happened from that point forward subject to optional untilTimestamp parameter and page size limit (currently 40000 records but this could change). It will also include a pointer to the next page (paginationToken) to be used for a subsequent call. This endpoint should be polled hourly to fetch new events.
For convenience, we provide a shouldContinuePolling flag to signal if data has been published at the location of the nextUrl. Since the endpoint will return as much data as it can, unless there is more data that can fit in a single response, this flag will usually be false as all available data has been returned.
The endpoint is designed for paging forward through data in order to populate your local database. By relying on the nextUrl parameter provided in the preceding call's response, we can guarantee a) you will see no gaps, and b) you will see no duplicates.
If constructing the url manually, subsequent requests should use paginationToken from the last response and omit sinceTimestamp.
This endpoint should be polled no more frequently than every 5 minutes, we recommend hourly. Data for this endpoint is made available with a 5 minute SLA. If the current time is '2020-01-01T00:15:00Z' UTC, making a request to this endpoint with the timestamp set to '2020-01-01T00:14:00Z' will error because of the 5 minute SLA. Making a request with a timestamp of '2020-01-01T00:09:00Z' however will succeed.
Parameters
Name
Type
Required
Description
sinceTimestamp
string [date-time]
false
The lower bound for when an event hit Engine's system. Use this on your initial request.
untilTimestamp
string [date-time]
false
The upper bound of events to include (exclusive - timestamps less than this parameter)
paginationToken
string
false
Opaque cursor for subsequent requests. Obtained from previous response.
API-Version
string
true
Supply Analytics API version header. Must be set to 2025-04-01 for v3.
[
{
"attribute": "timestamp",
"type": "missing",
"message": "timestamp must be specified"
}
]
[
{
"attribute": "timestamp",
"type": "malformed",
"details": {
"specified": "2021-02-01T17:00:00.000Z",
"requirement": "must be at or before 2021-01-13T16:00:00Z"
},
"message": "timestamp must be at or before 2021-01-13T16:00:00Z, but is '2021-02-01T17:00:00Z'"
}
]
Client tags (also known as Custom Lead Attributes) are arbitrary key:value pairs of information that can be set using the API or URL of a partner page to enable custom segmentation. Client tags provides you a method to be able to segment leads to support uses cases like:
See how various traffic sources on the supply partners site perform
See what preferences their users from different segments have
The lead client tag endpoint returns client tags associated with a lead.
Client tags are intended for segmentation and attribution (e.g., campaign ID, article source, user cohort). They should not contain personally identifiable information (PII) such as names, email addresses, phone numbers, or social security numbers.
For more information on how to send client tags to Engine please refer to: https://engine.tech/developer-center/references/appendix/appendix-e-appending-client-tags-to-leads-posted-to-engine
How does it work?
The endpoint is cursor based. You can consume batches of events for the product tied to your company uuid. All that is required is a bearer token and previous paginationToken or sinceTimestamp. The endpoint will respond with all of the events that have happened from that point forward subject to optional untilTimestamp parameter and page size limit (currently 40000 records but this could change). It will also include a pointer to the next page (paginationToken) to be used for a subsequent call. This endpoint should be polled hourly to fetch new events.
For convenience, we provide a shouldContinuePolling flag to signal if data has been published at the location of the nextUrl. Since the endpoint will return as much data as it can, unless there is more data that can fit in a single response, this flag will usually be false as all available data has been returned.
The endpoint is designed for paging forward through data in order to populate your local database. By relying on the “nextUrl” parameter provided in the preceding call’s response, we can guarantee a) you will see no gaps, and b) you will see no duplicates.
If constructing the url manually, subsequent requests should use paginationToken from the last response and omit sinceTimestamp.
This endpoint should be polled no more frequently than every 5 minutes, we recommend hourly. Data for this endpoint is made available with a 5 minute SLA. If the current time is '2020-01-01T00:15:00Z' UTC, making a request to this endpoint with the timestamp set to '2020-01-01T00:14:00Z' will error because of the 5 minute SLA. Making a request with a timestamp of '2020-01-01T00:09:00Z' however will succeed.
Parameters
Name
Type
Required
Description
sinceTimestamp
string [date-time]
false
The lower bound for when an event hit Engine's system. Use this on your initial request.
untilTimestamp
string [date-time]
false
The upper bound of events to include (exclusive - timestamps less than this parameter)
paginationToken
string
false
Opaque cursor for subsequent requests. Obtained from previous response.
API-Version
string
true
Supply Analytics API version header. Must be set to 2025-04-01 for v3.
[
{
"attribute": "timestamp",
"type": "missing",
"message": "timestamp must be specified"
}
]
[
{
"attribute": "timestamp",
"type": "malformed",
"details": {
"specified": "2021-02-01T17:00:00.000Z",
"requirement": "must be at or before 2021-01-13T16:00:00Z"
},
"message": "timestamp must be at or before 2021-01-13T16:00:00Z, but is '2021-02-01T17:00:00Z'"
}
]
Provides a snapshot of all information about a lead - events, payouts and client tags.
In rare cases with extremely large data volume, results may be truncated to fit the response size limit and HTTP 206 will be returned along with warnings.
Parameters
Name
Type
Required
Description
leadUuid
string [uuid]
true
The UUID of the lead you wish to obtain the information for.
API-Version
string
true
Supply Analytics API version header. Must be set to 2025-04-01 for v3.
Get a list of university names that correspond to the specified fragment.
This is useful for implementing an autocomplete input for the educationInformation.universityAttended lead field when searching for student loan refinancing loans. See the Student Loan Refinancing overview.
Parameters
Name
Type
Required
Description
name
string
false
Fragment of a university name to seach for.
offset
integer [int64]
false
Number of results to skip before the first returned result.
limit
integer [int32]
true
Maximum number of results to return.
Example responses
Success
[
"Johns Hopkins University",
"Johns Hopkins University - Carey Business School",
"Johns Hopkins University - Paul Nifle School of Advanced International Studies",
"Johns Hopkins University - Peabody Conservatory of Music",
"Johns Hopkins University - School of Arts & Science",
"Johns Hopkins University - School of Medicine",
"Johns Hopkins University - School of Nursing",
"Johns Hopkins University - School of Public Health",
"Johns Hopkins University - SPSBE",
"Saint Johns University",
"Cornell University Johnson, MBA",
"Johnson College",
"Johnson County Community College",
"Johnson University",
"Johnson & Wales University",
"Northern Vermont University - Johnson (FKA Johnson State College + Lyndon State College)",
"Northern Vermont University - Lyndon (FKA Lyndon State College + Johnson State College)",
"University of Pittsburgh - Johnstown"
]
This is useful for implementing a select input for vehicle years when searching for auto loan refinancing loans. A valid combination of year, make, model, and trim corresponds to a vehicle UUID that can be used in the vehicleInformation.vehicleUuid field. See the Auto Loan Refinancing overview.
This is useful for implementing a select input for vehicle makes when searching for auto loan refinancing loans. A valid combination of year, make, model, and trim corresponds to a vehicle UUID that can be used in the vehicleInformation.vehicleUuid field. See the Auto Loan Refinancing overview.
Get all models for the given vehicle year and make
This is useful for implementing a select input for vehicle models when searching for auto loan refinancing loans. A valid combination of year, make, model, and trim corresponds to a vehicle UUID that can be used in the vehicleInformation.vehicleUuid field. See the Auto Loan Refinancing overview.
Get vehicle details, including trims and uuids, for the given year, make, and model
This is useful for implementing a select input for vehicle trims when searching for auto loan refinancing loans. A valid combination of year, make, model, and trim corresponds to a vehicle UUID that can be used in the vehicleInformation.vehicleUuid field. The uuid field returned in successful response objects corresponds to a valid vehicleUuid. See the Auto Loan Refinancing overview.
Get a list of featured financial institution names and logos that can be displayed prior to collecting personal information in a search application to improve the user experience.
{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}
curl -X POST 'https://api.engine.tech/originator/prefills' \
-H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer {access-token}' \
-d @- << EOF
{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}
EOF
fetch('https://api.engine.tech/originator/prefills', {
method: 'POST',
headers: {
'Content-Type':'application/json',
'Accept':'application/json',
'Authorization':'Bearer {access-token}'
},
body: `{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}`
}).then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});
import requests
import json
response = requests.post(
'https://api.engine.tech/originator/prefills',
headers={
'Content-Type': 'application/json',
'Accept': 'application/json',
'Authorization': 'Bearer {access-token}'
},
json=json.loads("""{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}""")
)
print(response.json())
require 'rest-client'
require 'json'
response = RestClient.post(
'https://api.engine.tech/originator/prefills',
%q|{
"productTypes": [
"loan",
"savings"
],
"personalInformation": {
"firstName": "John",
"lastName": "Doe",
"email": "[email protected]",
"city": "New York",
"state": "NY",
"workPhone": "2125551234",
"primaryPhone": "2125556789",
"address1": "45 West 21st Street",
"address2": "5th Floor",
"zipcode": "10010",
"monthsAtAddress": 5,
"driversLicenseNumber": "111222333",
"driversLicenseState": "NY",
"ipAddress": "8.8.8.8",
"activeMilitary": false,
"militaryVeteran": true,
"dateOfBirth": "1993-10-09",
"ssn": "111-22-3333"
},
"loanInformation": {
"purpose": "debt_consolidation",
"loanAmount": 10000
},
"mortgageInformation": {
"propertyType": "condo",
"propertyStatus": "own_with_mortgage",
"propertyValue": 200000,
"mortgageBalance": 10000,
"lenderName": "Bank OF NY",
"hasFHALoan": true,
"currentWithLoan": true
},
"creditCardInformation": {
"allowAnnualFee": true,
"cardPurposes": [
"travel_incentives"
]
},
"savingsInformation": {
"minDepositAmount": 1000
},
"creditInformation": {
"providedCreditRating": "excellent",
"providedNumericCreditScore": 750
},
"financialInformation": {
"creditCardDebt": 5000,
"employmentStatus": "employed",
"employmentPayFrequency": "weekly",
"annualIncome": 120000,
"monthlyNetIncome": 10000,
"bankName": "Santander",
"bankRoutingNumber": "231372691",
"bankAccountType": "savings",
"monthsAtBank": 10,
"bankAccountNumber": "1234567890"
},
"employmentInformation": {
"employerName": "Engine by Gen",
"employerAddress": "45 W 21st St",
"employerCity": "New York",
"employerState": "NY",
"employerZip": "10010",
"jobTitle": "Software Engineer",
"monthsEmployed": 14,
"directDeposit": true,
"payDate1": "2004-10-06",
"payDate2": "2004-11-06"
},
"educationInformation": {
"educationLevel": "masters",
"graduateDegreeType": "master_of_science",
"universityAttended": "Johns Hopkins University"
},
"coApplicantInformation": {
"firstName": "Jane",
"lastName": "Doe",
"dateOfBirth": "1984-03-06",
"annualIncome": 100000,
"streetAddress1": "45 West 21st Street",
"streetAddress2": "5th Floor",
"city": "New York",
"state": "NY",
"zipcode": "10010"
},
"healthInformation": {
"gender": "male",
"heightInInches": 72,
"weightInPounds": 195,
"tobaccoSmoker": false
},
"autoInsuranceInformation": {
"numberOfVehicles": 1,
"hasAutoInsurance": true
},
"legalInformation": {
"consentsToFcra": true,
"consentsToTcpa": true,
"fcraLanguage": "By checking this box/clicking 'agree' I hereby consent to the 'E-Sign Agreement', the 'Credit Authorization Agreement', the Terms of Service and Privacy Policy, and I am providing written consent under the Fair Credit Reporting Act (FCRA) for [Engine by Gen and/or Insert Company Name], its partners and financial institutions to obtain consumer report information from my credit profile. I request that my information be provided to their partners, lenders, and financial services partners to provide me with financial recommendations, which may also include debt relief, credit repair, credit monitoring or other related services",
"tcpaLanguage": "I agree to be contacted by [Engine by Gen and/or Insert Company Name] its partners and their affiliated companies and financial institutions via email, postal mail service and/or at the telephone number(s) I have provided above to explore various financial products and services I inquired about, including contact through automatic dialing systems, artificial or pre-recorded voice messaging, or text message. Consent is not required as a condition to utilize the service, and you may choose to be contacted by an individual customer care representative(s) by calling XXXXX or emailing XXXX"
},
"clientTags": {
"hello": [
"world",
"there"
],
"something": [
"else"
]
}
}|,
{
'Content-Type' => 'application/json',
'Accept' => 'application/json',
'Authorization' => 'Bearer {access-token}'
}
)
p JSON.parse(response)
GET /leads/{leadUuid}/autoInsurance/vehicles/makes/{year}
Returns all available auto insurance vehicle makes for the given year. Use each make's id as the {make} path parameter in the models endpoint. Submit each make's name as vehicles[n].make on the lead.
GET /leads/{leadUuid}/autoInsurance/vehicles/models/{year}/{make}
Returns all available auto insurance vehicle models for the given year and make. Use each model's id as the {model} path parameter in the trims endpoint. Use each model's name as vehicles[n].model on the lead.
GET /leads/{leadUuid}/autoInsurance/vehicles/trims/{year}/{make}/{model}
Returns all available auto insurance vehicle trims for the given year, make, and model. Use the trim value for display. Submit trim.vinStub as vehicles[n].vin on the lead.
Represents the APR of an offer in basis points (e.g. 200 instead of 2.00%). It should NOT be set for static offers; it is used for dynamic offers only.
createdAt
string [date-time]
true
descriptionPoints
string array
false
Marketing bullets displayed in the 'More Info' section of the offer.
financialInstitutionDisplayName
string
true
financialInstitutionImageUrl
string [uri]
true
financialInstitutionUuid
string [uuid]
true
firmness
string
true
Refers to the level of qualification for an offer. 'None' refers to static (aka Thin Verticals) type offers with no decisioning. 'Rate Quote' offers are Mortech-created dynamic offers with a higher level of decisioning. Only 'None' should be used for static offers in Offer Catalog.
headline
string
false
In some placements / UX (e.g. Offer Carousel), we display a headline above marketing bullets. For example, this could be 'Get cash advances up to $250* and build smart spending habits'.
isMonetized
boolean
false
legalLanguage
string
false
lenderFeesAndCredits
object
false
loanProgram
string
false
Represents the specific type of mortgage; 'conforming' refers to a standard mortgage type. This should NOT be set for static offers.
minCreditScore
integer
false
monthlyPaymentCents
integer
false
Only used for dynamically created offers. Do NOT set for static offers.
nmlsId
integer
false
The lender's official NMLS ID. Can be sourced online or from the lender.
productDisplayName
string
true
productType
string
true
productVersions
number array
true
rank
integer
false
rateBasisPoints
integer
false
Similar to annualPercentageRateBasisPoints, but is a rate instead of APR so excludes specific fees in the calculation. This should NOT be set for static offers.
recommendationScore
number,null
[...]
